package com.teamchat.sdk.sample;

import android.app.Dialog;
import android.content.Context;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.support.v7.widget.Toolbar;
import android.text.TextUtils;
import android.view.LayoutInflater;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.EditText;
import android.widget.ListView;
import android.widget.TextView;
import android.widget.Toast;


import com.webaroo.teamchatsdk.sdk.Teamchat;

import java.util.ArrayList;
import java.util.EnumSet;


public class Contacts extends AppCompatActivity {
    EnumSet<Teamchat.ContactType> set;
    private ListView mList;
    private CustomAdapter adapter;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_contacts);
        Toolbar toolbar = (Toolbar) findViewById(R.id.toolbar);
        setSupportActionBar(toolbar);
        setTitle("TestApp");
        set = EnumSet.noneOf(Teamchat.ContactType.class);
        if(MainActivity.mContacts == null)
            MainActivity.mContacts = new ArrayList<>();
        mList = (ListView) findViewById(R.id.contact_list);
        adapter = new CustomAdapter(this);
        mList.setAdapter(adapter);
        findViewById(R.id.add_contact).setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                final Dialog dialog = new Dialog(Contacts.this);
                dialog.setContentView(R.layout.new_contact);
                dialog.setTitle("New contact");
                final EditText newEmail = (EditText) dialog.findViewById(R.id.new_email);
                final EditText newName = (EditText) dialog.findViewById(R.id.new_name);
                final EditText newPhone = (EditText) dialog.findViewById(R.id.new_phone);
                dialog.findViewById(R.id.add_new_contact).setOnClickListener(new View.OnClickListener() {
                    @Override
                    public void onClick(View v) {
                        String name = newName.getText().toString();
                        String email = newEmail.getText().toString();
                        String phone = newPhone.getText().toString();
                        if(!TextUtils.isEmpty(email)|| !TextUtils.isEmpty(phone)){
                            Teamchat.TCTeamchatContact contact = new Teamchat.TCTeamchatContact();
                            contact.profileName = name;
                            contact.email = email;
                            contact.phone = phone;
                            MainActivity.mContacts.add(contact);
                            adapter.notifyDataSetChanged();
                            dialog.dismiss();
                        }
                        else {
                            Toast.makeText(Contacts.this,"Enter phone/email", Toast.LENGTH_SHORT).show();
                        }
                    }
                });
                dialog.show();
            }
        });
    }

    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        // Inflate the menu; this adds items to the action bar if it is present.
        getMenuInflater().inflate(R.menu.menu_contacts, menu);
        return true;
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        // Handle action bar item clicks here. The action bar will
        // automatically handle clicks on the Home/Up button, so long
        // as you specify a parent activity in AndroidManifest.xml.
        int id = item.getItemId();

        //noinspection SimplifiableIfStatement
        if (id == R.id.custom) {
            if (item.isChecked()){
                item.setChecked(false);
                set.remove(Teamchat.ContactType.ShowCustomAddressBookContacts);
            } else  {
                item.setChecked(true);
                set.add(Teamchat.ContactType.ShowCustomAddressBookContacts);
            }
        } else if (id == R.id.server) {
            if (item.isChecked()){
                item.setChecked(false);
                set.remove(Teamchat.ContactType.ShowServerAddressBookContacts);
            } else  {
                item.setChecked(true);
                set.add(Teamchat.ContactType.ShowServerAddressBookContacts);
            }
        } else  if (id == R.id.local) {
            if (item.isChecked()){
                item.setChecked(false);
                set.remove(Teamchat.ContactType.ShowLocalAddressBookContacts);
            } else  {
                item.setChecked(true);
                set.add(Teamchat.ContactType.ShowLocalAddressBookContacts);
            }
        }
        Teamchat.setShowContactOptions(set);
        return  true;
    }

    public static class ViewHolder {

        public TextView name;
        public TextView email;
        public TextView phone;

    }

    class CustomAdapter extends BaseAdapter {
        private final LayoutInflater inflater;
        CustomAdapter(Context context) {
            inflater = (LayoutInflater)context.
                    getSystemService(Context.LAYOUT_INFLATER_SERVICE);
        }

        @Override
        public int getCount() {
            return MainActivity.mContacts.size();
        }

        @Override
        public Object getItem(int position) {
            return null;
        }

        @Override
        public long getItemId(int position) {
            return 0;
        }

        @Override
        public View getView(int position, View convertView, ViewGroup parent) {
            ViewHolder holder;
            View vi = convertView;
            if (convertView == null) {
                vi = inflater.inflate(R.layout.contact_list_item, null);
                holder = new ViewHolder();
                holder.email = (TextView) vi.findViewById(R.id.email);
                holder.name = (TextView) vi.findViewById(R.id.name);
                holder.phone = (TextView) vi.findViewById(R.id.phone);
                vi.setTag(holder);
            } else
                holder = (ViewHolder) convertView.getTag();

            holder.name.setText("Name: "+MainActivity.mContacts.get(position).profileName);
            holder.email.setText("Email: "+ MainActivity.mContacts.get(position).email);
            holder.phone.setText("Phone: "+ MainActivity.mContacts.get(position).phone);
            return vi;
        }
    }
}
