package com.teamchat.sdk.sample;

import android.support.v7.app.AlertDialog;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.text.TextUtils;
import android.util.Log;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.widget.EditText;
import android.widget.TextView;

import com.webaroo.teamchatsdk.sdk.Teamchat;


public class LoginActivity extends AppCompatActivity {

    private AlertDialog dilog;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_login);
        final TextView text = (TextView)findViewById(R.id.textmsg);
        dilog = new AlertDialog.Builder(this).create();
        dilog.setTitle("Teamchat");
        dilog.setMessage("Initializing");
        dilog.setCancelable(false);

        findViewById(R.id.login_button).setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                String email = ((EditText) findViewById(R.id.lofin_edittext)).getText().toString();
                if (!TextUtils.isEmpty(email)) {
                    Teamchat.setUserEmailID(email, LoginActivity.this);
                }
                Teamchat.login(LoginActivity.this, new Teamchat.LoginCompletionHandler() {

                    @Override
                    public void onLoginCompletion(boolean success, String message) {
                        if (success) {
                            Log.d("Teamchat", "__________login done, session: " + Teamchat.hasActiveSession(LoginActivity.this));
                            findViewById(R.id.progressbar).setVisibility(View.VISIBLE);
                            initialize();
                            dilog.show();
                        } else {
                            text.setText(message);
                        }
                    }
                });
            }
        });
    }

    private void initialize(){
        Teamchat.initWithCompletionHandler(new Teamchat.TeamchatStartCompletionHandler() {
            @Override
            public void onTeamchatStartCompletionHandler(boolean success, String error, String messaeg) {
                if (success) {
                    Log.d("Teamchat", "__________initialization done, session:" + Teamchat.hasActiveSession(LoginActivity.this));
                    findViewById(R.id.progressbar).setVisibility(View.GONE);
                    dilog.dismiss();
                    finish();
                } else {
                    Log.d("Teamchat", "__________initialization done:" + error + " " + messaeg);
                    findViewById(R.id.progressbar).setVisibility(View.GONE);
                    ((TextView) findViewById(R.id.textmsg)).setText(error);
                    dilog.dismiss();
                }
            }
        }, this);
    }
    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        // Inflate the menu; this adds items to the action bar if it is present.
        getMenuInflater().inflate(R.menu.menu_login, menu);
        return true;
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        // Handle action bar item clicks here. The action bar will
        // automatically handle clicks on the Home/Up button, so long
        // as you specify a parent activity in AndroidManifest.xml.
        int id = item.getItemId();

        //noinspection SimplifiableIfStatement
        if (id == R.id.action_settings) {
            return true;
        }

        return super.onOptionsItemSelected(item);
    }
}
