package com.teamchat.sdk.sample;

import android.support.v7.app.AlertDialog;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.text.TextUtils;
import android.util.Log;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;
import android.widget.TextView;

import com.webaroo.teamchatsdk.sdk.Teamchat;


public class LoginWithToken extends AppCompatActivity {

    private EditText email;
    private EditText id;
    private EditText gupshup;
    Button initializebutton;
    private AlertDialog dilog;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_login_with_token);
        email = ((EditText) findViewById(R.id.email));
        id = ((EditText) findViewById(R.id.id));
        gupshup = ((EditText) findViewById(R.id.token));
        initializebutton = (Button)findViewById(R.id.initialize);
        dilog = new AlertDialog.Builder(this).create();
        dilog.setTitle("Teamchat");
        dilog.setMessage("Initializing");
        dilog.setCancelable(false);

        final Teamchat.TeamchatStartCompletionHandler teamchatStartCompletionHandler = new Teamchat.TeamchatStartCompletionHandler() {
            @Override
            public void onTeamchatStartCompletionHandler(boolean success, String error, String messaeg) {
                if (success) {
                    Log.d("Teamchat", "________initialization succ");
                    ((TextView) findViewById(R.id.textview_2)).setText("session is active now");
                    initializebutton.setVisibility(View.GONE);
                    dilog.dismiss();
                } else {
                    Log.d("Teamchat", "________initialization failed: " + " " + error + " " + messaeg);
                    ((TextView) findViewById(R.id.textview_2)).setText(error);
                    initializebutton.setVisibility(View.VISIBLE);
                    dilog.dismiss();
                }
            }
        };


        initializebutton.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                initializebutton.setVisibility(View.GONE);
                ((TextView) findViewById(R.id.textview_2)).setText("working...");
                String gupshupid= gupshup.getText().toString();
                String emailid =email.getText().toString();
                String userid =id.getText().toString();
                if(!TextUtils.isEmpty(gupshupid))
                    Teamchat.setAuthenticationCode(gupshupid, LoginWithToken.this);
                if(!TextUtils.isEmpty(emailid))
                    Teamchat.setUserEmailID(emailid, LoginWithToken.this);
                if(!TextUtils.isEmpty(userid))
                    Teamchat.setUserID(Integer.parseInt(userid), LoginWithToken.this);
                Teamchat.initWithCompletionHandler(teamchatStartCompletionHandler, LoginWithToken.this);
                dilog.show();
            }
        });
    }

    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        // Inflate the menu; this adds items to the action bar if it is present.
        getMenuInflater().inflate(R.menu.menu_login_with_token, menu);
        return true;
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        // Handle action bar item clicks here. The action bar will
        // automatically handle clicks on the Home/Up button, so long
        // as you specify a parent activity in AndroidManifest.xml.
        int id = item.getItemId();

        //noinspection SimplifiableIfStatement
        if (id == R.id.action_settings) {
            return true;
        }

        return super.onOptionsItemSelected(item);
    }
}
