package com.teamchat.sdk.sample;

import android.content.Intent;
import android.graphics.Bitmap;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.support.v7.widget.Toolbar;
import android.text.TextUtils;
import android.util.Log;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.widget.Button;
import android.widget.ImageView;
import android.widget.TextView;
import android.widget.Toast;
import com.webaroo.teamchatsdk.sdk.Teamchat;
import com.webaroo.teamchatsdk.sdk.TeamchatError;
import com.webaroo.teamchatsdk.sdk.TeamchatGroupCreator;

import java.util.ArrayList;
import java.util.EnumSet;
import java.util.Random;

public class MainActivity extends AppCompatActivity implements Teamchat.AddressBookContactProvider{

    TextView textView;

//    Button ersetsessionButton;
    Button showroomsbutton;
    Button loginbutton;
    private Button loginwithToken, openRoom,showPublicRooms, showProfile;
    public static ArrayList<Teamchat.TCTeamchatContact> mContacts;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);
        Toolbar toolbar = (Toolbar) findViewById(R.id.toolbar);
        setSupportActionBar(toolbar);
        setTitle("TestApp");
        textView = ((TextView) findViewById(R.id.textview));
        Bitmap image = Teamchat.TeamchatSplashScreenWithLogo.coBrandingImage(this);
        if(image!=null){
            ((ImageView)findViewById(R.id.cobrand)).setImageBitmap(image);
        } else
            Log.d("SDK","null");
        image = Teamchat.TeamchatSplashScreenWithLogo.logoImage(this);
        if(image!=null){
            Log.d("SDK","logo"+image.getHeight());
            ((ImageView)findViewById(R.id.cobrandlogo)).setImageBitmap(image);
        } else
            Log.d("SDK","null");
//        ersetsessionButton = (Button) findViewById(R.id.reset_session);
        showroomsbutton = (Button) findViewById(R.id.go);
        loginbutton = (Button) findViewById(R.id.login_totc);
        loginwithToken = (Button) findViewById(R.id.login_with_token);
        openRoom = (Button) findViewById(R.id.open_room);
        showPublicRooms = (Button)findViewById(R.id.show_public_rooms);
        showProfile = (Button) findViewById(R.id.show_profile);
        Teamchat.setNavigationTitle(this, "Test App");
        Teamchat.setChatListItemSelector(R.drawable.bg, this);
//        Teamchat.setMediaIcon(R.mipmap.search_view_close, this);
//        Teamchat.setChatletIcon(R.mipmap.search_view_right_icon, this);

        showroomsbutton.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                if (Teamchat.hasActiveSession(MainActivity.this)) {
                    Teamchat.showRoomList(MainActivity.this);
                } else {
                    ((TextView) findViewById(R.id.textview)).setText("No active session...");
                }

            }
        });

//        ersetsessionButton.setOnClickListener(new View.OnClickListener() {
//            @Override
//            public void onClick(View v) {
//                Teamchat.resetTeamchatSession(MainActivity.this);
//                textView.setText("Session reset");
//                findViewById(R.id.action_section).setVisibility(View.GONE);
//                findViewById(R.id.login_section).setVisibility(View.VISIBLE);
//            }
//        });

        loginbutton.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                Intent intent = new Intent(MainActivity.this, LoginActivity.class);
                startActivity(intent);
            }
        });

        loginwithToken.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                Intent intent = new Intent(MainActivity.this, LoginWithToken.class);
                startActivity(intent);
            }
        });

        openRoom.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                Intent intent = new Intent(MainActivity.this, RoomList.class);
                startActivity(intent);
            }
        });
        findViewById(R.id.go_to_contacts).setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                Intent intent = new Intent(MainActivity.this, Contacts.class);
                startActivity(intent);
            }
        });
        EnumSet<Teamchat.ContactType> set = EnumSet.of(Teamchat.ContactType.ShowCustomAddressBookContacts,
                Teamchat.ContactType.ShowLocalAddressBookContacts,
                Teamchat.ContactType.ShowServerAddressBookContacts);
        Teamchat.setShowContactOptions(set);
        Teamchat.setCustomAddressBookContactProvider(this);
        showPublicRooms.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                Teamchat.showPublicGroups(MainActivity.this);
            }
        });
        showProfile.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                Teamchat.showProfile(MainActivity.this);
            }
        });

//        setNavigationDrawer();
    }

//    private void setNavigationDrawer() {
//        View view = getLayoutInflater().inflate(com.webaroo.teamchat.R.layout.navigation_left_slider_menu_layout,null);
//
//        View.OnClickListener listner;
//        listner = new View.OnClickListener() {
//            @Override
//            public void onClick(View v) {
//                int i = v.getId();
//                if (i == R.id.profile_drawer_chats_layout) {
//                    Teamchat.closeDrawer();
//                    Teamchat.fiishTopActivity();
//                    Teamchat.showRoomList(MainActivity.this);
//                }
//                else if (i == R.id.profile_drawer_settings_layout) {
//                    Teamchat.closeDrawer();
//                    Teamchat.fiishTopActivity();
//                    Teamchat.showSettings(MainActivity.this);
//                }
//                else if (i == R.id.profile_drawer_open_groups_layout) {
//                    Teamchat.closeDrawer();
//                    Teamchat.fiishTopActivity();
//                    Teamchat.showPublicGroups(MainActivity.this);
//                }
//                else if (i == R.id.profile_drawer_profile_details_layout) {
//                    Teamchat.closeDrawer();
//                    Teamchat.showProfile(MainActivity.this);
//                }
//                else if (i == R.id.profile_drawer_invite_layout) {
//
//                } else if (i == R.id.profile_drawer_about_layout) {
//
//                } else if (i == R.id.profile_drawer_tour_layout1) {
//
//                } else {
//
//                }
//            }
//        };
//        view.findViewById(R.id.profile_drawer_chats_layout).setOnClickListener(listner);
//        view.findViewById(R.id.profile_drawer_open_groups_layout).setOnClickListener(listner);
//        view.findViewById(R.id.profile_drawer_profile_details_layout).setOnClickListener(listner);
//        view.findViewById(R.id.profile_drawer_settings_layout).setOnClickListener(listner);
//        Teamchat.setNavigationDrawerVew(view);
//
//    }

    @Override
    protected void onResume() {
        super.onResume();
        if (Teamchat.hasActiveSession(this)) {
            textView.setText("Session is active.");
            findViewById(R.id.action_section).setVisibility(View.VISIBLE);
            findViewById(R.id.login_section).setVisibility(View.GONE);
            if(Teamchat.isSandBoxingEnabled(this))
            {
                findViewById(R.id.enable_sandboxing).setEnabled(false);
            }
            else
            {
                findViewById(R.id.disable_sandboxing).setEnabled(false);
            }
        } else {
            if(TextUtils.isEmpty(Teamchat.getHostURL(this)))
                Teamchat.setHostURL("https://qa-enterprise.teamchat.com/", this);
            findViewById(R.id.action_section).setVisibility(View.GONE);
            findViewById(R.id.login_section).setVisibility(View.VISIBLE);
            Teamchat.initializeWithAppID("asd", new Teamchat.TeamchatInitializationWithAppIDCompletionHandler() {
                @Override
                public void onTeamchatInitializationWithAppIDCompletion(boolean success, String message) {
                    if (success) {
                        Log.d("Teamchat", "________app idinitialization succ");
                        //setting the value for text fields programmatically for testing purpose,
                    } else
                        textView.setText("initialization failed");
                }
            }, this);
        }
    }


    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        // Inflate the menu; this adds items to the action bar if it is present.
        getMenuInflater().inflate(R.menu.menu_main, menu);
        return true;
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        // Handle action bar item clicks here. The action bar will
        // automatically handle clicks on the Home/Up button, so long
        // as you specify a parent activity in AndroidManifest.xml.
        int id = item.getItemId();

        //noinspection SimplifiableIfStatement
        if (id == R.id.action_settings) {
            Intent intent = new Intent(this, Settings.class);
            startActivity(intent);
            return true;
        }
        if (id == R.id.action_settings_sdk) {
            boolean result = Teamchat.showSettings(MainActivity.this);
            if(!result)
                Toast.makeText(getApplicationContext(), "No active session",
                        Toast.LENGTH_LONG).show();
            return true;
        }

        return super.onOptionsItemSelected(item);
    }

    @Override
    public ArrayList<Teamchat.TCTeamchatContact> customContacts() {
        return mContacts;
    }
//    private void registerInBackground() {
//        new AsyncTask<Object, Object, Object>() {
//        private GoogleCloudMessaging gcm;
//        private String regId;
//        @Override
//        protected Object doInBackground(Object... params) {
//            try {
//                  gcm = GoogleCloudMessaging.getInstance(MainActivity.this);
//                  regId = gcm.register("SenderId");
//                  Teamchat.setRemoteNotificationsDeviceToken(regId, MainActivity.this);
//                } catch (IOException ex) {
//                }
//                return regId;
//            }
//        }.executeOnExecutor(AsyncTask.THREAD_POOL_EXECUTOR);
//    }

    public void createGroup(View view)
    {
        TeamchatGroupCreator creator = new TeamchatGroupCreator();
        Random rand= new Random();

        int pick = rand.nextInt(1000);
        creator.setGroupName("Group " + pick);
        ArrayList<Teamchat.TCTeamchatContact> groupMembers = new ArrayList<Teamchat.TCTeamchatContact>();

        Teamchat.TCTeamchatContact contact1 = new Teamchat.TCTeamchatContact();
        contact1.email = "abc@gmail.com";
        contact1.profileName = "abc";

        Teamchat.TCTeamchatContact contact2 = new Teamchat.TCTeamchatContact();
        contact2.email = "def@gmail.com";
        contact2.profileName = "def";

        Teamchat.TCTeamchatContact contact3 = new Teamchat.TCTeamchatContact();
        contact3.phone = "0123456789";
        contact3.profileName = "abc";

        Teamchat.TCTeamchatContact contact4 = new Teamchat.TCTeamchatContact();
        contact4.phone = "1234567890";
        contact4.profileName = "def";

        Teamchat.TCTeamchatContact contact5 = new Teamchat.TCTeamchatContact();
        contact5.email = "akshaya.rao@robosoftin.com";
        contact5.phone = "2345678901";
        contact5.profileName = "akshay";

        Teamchat.TCTeamchatContact contact6 = new Teamchat.TCTeamchatContact();
        contact6.email = "ranjith.yadav@robosoftin.com";
        contact6.phone = "3456789012";
        contact6.profileName = "ranjith";

        groupMembers.add(contact1);
        groupMembers.add(contact2);
        groupMembers.add(contact3);
        groupMembers.add(contact4);
        groupMembers.add(contact5);
        groupMembers.add(contact6);

        creator.setGroupMembers(groupMembers);
        creator.setAdminOnly(true);
        creator.setShouldHideMemberProfiles(true);
        creator.createGroupWithCompletionHandler(MainActivity.this, new TeamchatGroupCreator.TeamchatGroupCreationCompletionHandler() {
            @Override
            public void onTeamchatGroupCreationComplete(boolean success, TeamchatError error, String message, Teamchat.TeamchatGroup createdGroup) {
                if(success)
                    Toast.makeText(MainActivity.this, "Group created successfully.", Toast.LENGTH_LONG).show();
                else
                {
                    String errorMessage = "";
                    if(error != null)
                        errorMessage = error.getErrorMessage();
                    Toast.makeText(MainActivity.this, "Failed creating Group. " + errorMessage, Toast.LENGTH_LONG).show();
                }
            }
        });
    }

    public void enablePassLock(View view)
    {
        Teamchat.enablePassLock(this);
    }

    public void disablePassLock(View view)
    {
        Teamchat.disablePassLock(this);
    }

    public void resetPasscode(View view)
    {
        Teamchat.resetPassCode(this);
    }

    public void enableSandBoxing(View view)
    {
        Teamchat.enableSandBoxing(this);
        findViewById(R.id.enable_sandboxing).setEnabled(false);
        findViewById(R.id.disable_sandboxing).setEnabled(true);
    }

    public void disableSandBoxing(View view)
    {
        Teamchat.disableSandBoxing(this);
        findViewById(R.id.disable_sandboxing).setEnabled(false);
        findViewById(R.id.enable_sandboxing).setEnabled(true);
    }

}
